#````````````````````````````
#  fR[h
#````````````````````````````
sub decode {
	my ($buffer, $pairs, $value, @pairs);

	if ($ENV{'REQUEST_METHOD'} eq 'POST') {
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	} else {
		$buffer = $ENV{'QUERY_STRING'};
	}

	@pairs = split(/&/, $buffer);

	foreach (@pairs) {
		($pairs, $value) = split(/=/, $_);

		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/&/&amp;/g;
		$value =~ s/"/&quot;/g;
		$value =~ s/'/&#39;/g;
		$value =~ s/\//&#47;/g;
		$value =~ s/\./&#046;/g;
		$value =~ s/</&lt;/g;
		$value =~ s/>/&gt;/g;
		$value =~ s/\t/  /g;
		$value =~ s/\0//g;
		$value =~ s/\r\n|\r|\n/<br>/g;

		&jcode'convert(*value,'sjis');
		$FORM{$pairs} = $value;
	}
}

#````````````````````````````
#  zXgl
#````````````````````````````
sub get_host {
	my ($addr, $host) = ($ENV{'REMOTE_ADDR'}, $ENV{'REMOTE_HOST'});

	if ($host eq $addr || !$host) {
		$host = gethostbyaddr(pack("C4", split(/\./,$addr)), 2) || $addr;
	}

	return $host;
}

#==============================================
#  ANZX`FbN
#==============================================
sub access_check {
	if (($refurl && (!$ENV{'HTTP_REFERER'} or $ENV{'HTTP_REFERER'} !~ /^$refurl/)) || (!$mobile and $ENV{'REQUEST_METHOD'} ne 'POST')) {
		&error("sȃANZXłB");
	}
	if ($endeny && $ENV{'HTTP_ACCEPT_LANGUAGE'} !~ /^(ja)/i) {
		&error('ERROR!');
	}
	# 񓚋֎~
	if ((grep ($_ eq $COOKIE{'name'}, @denynm))) {
		&error("񓚏o܂łB");
	}
}

#````````````````````````````
#  ANZX
#````````````````````````````
sub deny {

	my $denyflg;
	for (my $i = 0; $i < ((@deny)+(@deny2)); $i++) {
		# IPzXg
		if ($deny[$i]) {
			$deny[$i] =~ s/\./\\./g; $deny[$i] =~ s/\*/\.\*/g;
			if ($host =~ /$deny[$i]/i) { $denyflg = 1; last; }
		}

		# Cookie
		if ($deny2[$i]) {
			if ($COOKIE{'name'} eq $deny2[$i]) { $denyflg = 1; last; }
		}
	}

	if ($denyflg) {
		&error($denyms);
	}
}

#==============================================
#  NbL[o
#==============================================
sub set_cookie {
	my ($name, $pass) = @_;
	my (@mons, @week, $date, $cook);
	my ($sec, $min, $hour, $mday, $mon, $year, $wday) = gmtime(time + $cvalid*24*60*60);

	@mons = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	@week = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
	$date = sprintf("%s, %02d\-%s\-%04d %02d:%02d:%02d GMT",
						$week[$wday], $mday, $mons[$mon], $year+1900, $hour, $min, $sec);

	print "Set-Cookie: MMS=name\:$name\,pass:$pass; expires=$date\n";
}

#==============================================
#  NbL[ǂݏo
#==============================================
sub get_cookie {
	my ($name, $value, @pairs, %DUMMY, %COOKIE);

	@pairs = split(/\;/, $ENV{'HTTP_COOKIE'});

	foreach (@pairs) {
		($name, $value) = split(/\=/, $_);
		$name =~ s/ //g;
		$DUMMY{$name} = $value;
	}

	@pairs = split(/\,/, "$DUMMY{'MMS'}");

	foreach (@pairs) {
		($name, $value) = split(/\:/, $_);
		$COOKIE{$name} = $value;
	}

	return %COOKIE;
}

#````````````````````````````
#  pX[hÍ
#````````````````````````````
sub encrypt {
	my ($pass) = @_;

	my $xx = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	      . "abcdefghijklmnopqrstuvwxyz"
                 . "0123456789./";
	my $salt = substr($xx, int(rand(64)), 1);
	$salt .= substr($xx, int(rand(64)), 1);
	my $pwd = crypt($pass, $salt);

	return $pwd;
}

#````````````````````````````
#  F؊mF
#````````````````````````````
sub pass_check {
	my ($pass, $pwd) = @_;

	my $salt = substr($pwd,0,2);

	if (!$pass) {
		&error("pX[h͂Ă܂B");
	} elsif (!$pwd) {
		&error("pX[h͓o^Ă܂B");
	} elsif ($pwd ne crypt($pass, $salt) && $pass ne $mskey) {
		&error("pX[hԈĂ܂B");
	}
}

#````````````````````````````
#  bN
#````````````````````````````
sub lock {
	# 3ȏÂbN͉
	if (-e $lockdir) {
		my $mtime = (stat($lockdir))[9];
		if ($mtime < time - 60*3) { &unlock; }
	}

	my $retry = 5;

	while (!mkdir($lockdir, 0755)) {
		if (--$retry <= 0) {
			&error('rW[ԂłB΂炭҂ĂēxMĂB');
		}
		sleep(1);
	}

	$lockflg = 1;
}

#````````````````````````````
#  bN
#````````````````````````````
sub unlock {
	rmdir($lockdir);
	$lockflg = 0;
}

#````````````````````````````
#  t@Cǂݍ
#````````````````````````````
sub file_read {
	my ($file) = @_;

	open (FILE, "$file") || &error("t@C\"$file\"J܂łB");
		my @line = <FILE>;
	close (FILE);

	chomp (@line);

	return @line;
}

#````````````````````````````
#  t@C
#````````````````````````````
sub file_write {
	my ($file, @data) = @_;

	open (FILE, ">$file") || &error("t@C\"$file\"J܂łB");
		flock (FILE, 2) if ($lock == 1); # bN
		foreach (@data) {
			print FILE "$_\n";
		}
		seek (FILE, 0, 0) if ($lock == 1); # bN
	close (FILE);
}

#````````````````````````````
# wb_[
#````````````````````````````
sub header {
	my ($title) = @_;

	print "Content-type: text/html\n\n";
	print <<"_HTML_";
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=shift_jis">
<link rel="stylesheet" type="text/css" href="$style">
<title>$maintitle</title>
</head>
<body>
_HTML_

}

#````````````````````````````
# tb^[
#````````````````````````````
sub footer {
	print <<"_HTML_";
<hr>
<div align="center">
[<a href="$script?mode=how">Vѕ</a>]
[<a href="$script?mode=log">O</a>]
[<a href="$script?mode=ranking">LO</a>]

</div>
<hr>
<div align="right">
<small><a href="http://goo.gl/kxtdN">܂₩~jƂ Ver1.00</a></small>
</div>
</body>
</html>
_HTML_
}

#````````````````````````````
#  tl
#````````````````````````````
sub get_days{
	my ($sec, $min, $hour, $dy, $mon, $year, $wday, $yday, $isdst) = gmtime($_[0]+60*60*9);
	my @week = ('','','','','','','y');

	my $days = sprintf("%04d/%02d/%02d\(%s\) %02d:%02d", $year+1900, $mon+1, $dy, $week[$wday], $hour, $min);

	return $days;
}

#````````````````````````````
#  G[
#````````````````````````````
sub error {
	&error_mobile(@_) if ($mobile);

	&header('error');

	print qq(<p><table cellpadding="10"><tr><td><font color="#CC3333">G[</font><br>);

	foreach (@_) {
		print qq(<font color="#CC3333">&gt;&nbsp;</font>$_<br>);
	}

	print qq(
	</tr></td></table></p>
	<a href="JavaScript:history.back();">߂</a>
	<a href="JavaScript:window.close();"></a>
	</body></html>
	);

	exit;
}

1